/*
***** BEGIN GPL LICENSE BLOCK *****

--------------------------------------------------------------------------
LuxMax Autodesk 3ds Max to Luxrender exporter
--------------------------------------------------------------------------

Author:
Konstantinos Mourelas


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, see <http://www.gnu.org/licenses/>.

***** END GPL LICENCE BLOCK *****
*/

rollout Main "Settings" width:250 height:100 
(
	label lb1 "Initial Postition" across:1
	spinner sspx "x" range:[-10000,10000,0] align:#left width:50 across:3
	spinner sspy "y" range:[-10000,10000,0] align:#center width:50
	spinner sspz "z" range:[-10000,10000,0] align:#right width:50

	label empty1 ""  across:1

	label lb2 "Initial Rotation" across:1
	spinner ssprx "x" range:[-89,89,0] align:#left width:50 across:3
	spinner sspry "y" range:[-89,89,0] align:#center width:50
	spinner ssprz "z" range:[-89,89,0] align:#right width:50
	label lb7 "Randomize Initial Rotation" across:1
	spinner randomizerotationx "x" range:[-45,45,0] align:#left width:50 across:3
	spinner randomizerotationy "y" range:[-45,45,0] align:#center width:50 
	spinner randomizerotationz "z" range:[-45,45,0] align:#right width:50 
	
	label empty2 ""  across:1
	
	label lb3 "Animation" across:1
	spinner startframe "Start Frame" range:[0,10000,0] type:#integer align:#left width:75 across:2 
	spinner endframe "End Frame" range:[0,10000,100] type:#integer align:#right width:75

	label empty3 ""  across:1	
	
	checkbox chk1 "Randomize Objects Start Frame" across:1
	spinner objectduration "Object Animation Duration" range:[0,10000,20] type:#integer align:#left width:75  
	
	label empty4 ""  across:1
	label empty5 "---------" align:#center across:1

	label odigies "Select the objects and press -->" across:2 align:#left
	button sbt1 "Run" width:50 align:#right  



	on sbt1 pressed do
	(
		for obj in (selection as array) do
		(
			oldobjectpositionx = obj.pos.x
			oldobjectpositiony = obj.pos.y
			oldobjectpositionz = obj.pos.z
			oldobjectrotationx = obj.rotation.x_rotation
			oldobjectrotationy = obj.rotation.y_rotation
			oldobjectrotationz = obj.rotation.z_rotation
			
			
			with animate on
			(
				at time startframe.value 
				(
					obj.pos.x = obj.pos.x + sspx.value
					obj.pos.y = obj.pos.y + sspy.value
					obj.pos.z = obj.pos.z + sspz.value
					obj.rotation.x_rotation = obj.rotation.x_rotation + ssprx.value + random 0 randomizerotationx.value
					obj.rotation.y_rotation = obj.rotation.y_rotation + sspry.value + random 0 randomizerotationy.value 
					obj.rotation.z_rotation = obj.rotation.z_rotation + ssprz.value + random 0 randomizerotationz.value 
				)
				
				if chk1.checked == false then
				(
					at time endframe.value
					(
						obj.pos.x = oldobjectpositionx				
						obj.pos.y = oldobjectpositiony
						obj.pos.z = oldobjectpositionz	
						obj.rotation.x_rotation = oldobjectrotationx
						obj.rotation.y_rotation = oldobjectrotationy
						obj.rotation.z_rotation = oldobjectrotationz
					)
				)
				else
				(
					randomstart = random startframe.value (endframe.value - objectduration.value)
					at time (randomstart-1)
					(
						obj.pos.x = obj.pos.x + 0.1
						obj.pos.y = obj.pos.y + 0.1
						obj.pos.z = obj.pos.z + 0.1
						obj.rotation.x_rotation = obj.rotation.x_rotation + 0.1
						obj.rotation.y_rotation = obj.rotation.y_rotation + 0.1
						obj.rotation.z_rotation = obj.rotation.z_rotation + 0.1
					)	
					at time (randomstart + objectduration.value)
					(
						obj.pos.x = oldobjectpositionx				
						obj.pos.y = oldobjectpositiony
						obj.pos.z = oldobjectpositionz	
						obj.rotation.x_rotation = oldobjectrotationx
						obj.rotation.y_rotation = oldobjectrotationy
						obj.rotation.z_rotation = oldobjectrotationz
					)
				)										
			)
		)
	)
)
	
rf = newRolloutFloater "Building Scene Script" 250 320
addRollout Main rf